import { HttpErrorResponse } from '@angular/common/http';
import { AfterViewInit, Component, OnInit, ViewChild } from '@angular/core';
import { MatDialog } from '@angular/material/dialog';
import { MatPaginator } from '@angular/material/paginator';
import { MatSort } from '@angular/material/sort';
import { MatTableDataSource } from '@angular/material/table';
import { lastValueFrom } from 'rxjs';
import { HistoryOrder, ResponseDataHistoryOrder } from 'src/app/interfaces/acquisition-management/order.interface';
import { PartialDeliveriesService } from 'src/app/services/acquisition-management/partial-deliveries.service';
import { ResourcesService } from 'src/app/services/resources/resources.service';
import { DetailsStateOrderComponent } from '../../acquisition/orders/details-state-order/details-state-order.component';
import { UsersProfilesService } from 'src/app/services/users-profiles.service';
import { SocketService } from 'src/app/services/socket.service';
import { UserConsultResponse } from 'src/app/interfaces/user.interface';
import { EncService } from 'src/app/services/enc/enc.service';
import { ProfileInterface } from 'src/app/interfaces/profile.interface';
import { Router } from '@angular/router';


@Component({
  selector: 'app-partial-deliveries',
  templateUrl: './partial-deliveries.component.html',
  styleUrls: ['./partial-deliveries.component.css']
})
export class PartialDeliveriesComponent implements AfterViewInit, OnInit {

  public displayedColumns: Array<string>;
  public dataSource: MatTableDataSource<HistoryOrder>;
  @ViewChild(MatPaginator) paginator!: MatPaginator;
  @ViewChild(MatSort) sort!: MatSort;

  public isLoading: boolean;
  public isLoadingForm: boolean;

  constructor(
    private _partialDeliveriesService: PartialDeliveriesService,
    public resourcesService: ResourcesService,
    private _encService: EncService,
    private _router: Router,
    private _dialog: MatDialog,
    private _socketService: SocketService,
    private _usersProfilesSevice: UsersProfilesService,
  ) {
    this.displayedColumns = [ 'HIOR_NUOR','HIOR_FEMO','HIOR_USMO','HIOR_POEN','ACCIONES'];
    this.dataSource = new MatTableDataSource();
    this.isLoading = false;
    this.isLoadingForm = false;
    
  }

  async ngOnInit() {
    await this.refreshPermissions();
    await this.getPartialDeliveries();
  }

  ngAfterViewInit(): void {
    this.dataSource.paginator = this.paginator;
    this.dataSource.sort = this.sort;
  }

  private async refreshPermissions() {
    this._socketService.refreshPermissions().subscribe(async (profUpdEnc) => {
      let idUser = localStorage.getItem('idusuario')!;
      let usrInfo: UserConsultResponse = await lastValueFrom(this._usersProfilesSevice.getUser(idUser, idUser, 1));
      let currentProfile = await this._encService.decrypt(localStorage.getItem('perfil')!);

      if(parseInt(currentProfile) != usrInfo.response.PERFIL){
        this._router.navigate(['/sam/home']);
      }

      let profileUpdated = await this._encService.decrypt(`${profUpdEnc}`);
      if(profileUpdated == currentProfile){
        let profile = localStorage.getItem('perfil')!;

        await lastValueFrom(this._usersProfilesSevice.getProfile( profile, idUser, 1 )).then(
          (responseData: ProfileInterface) => {
            if (!responseData.error) {
              let modPerm = responseData.response.PERMISOS.permissions.filter(item => item.id == 'S002V01M05GEAD')[0];
              let funPerm = modPerm.children.filter(item => item.id == 'S002V03S03DESP')[0];
              let panPerm = funPerm.children.filter(item => item.id == "S002V01F02GEPA")[0];

              if (panPerm.access === 0) {
                this._router.navigate(['/sam/home']);
              }

            } else {
              this.resourcesService.openSnackBar(`${responseData.msg}`);
            }
          }, ( httpErrorResponse: HttpErrorResponse ) => this.resourcesService.checkErrors(httpErrorResponse)
        );
      }
    });
  }

  public async getPartialDeliveries() {
    this.isLoading = true;
    await lastValueFrom(this._partialDeliveriesService.getPartialDeliveries()).then(
      (responseData: ResponseDataHistoryOrder) => {
        if (!responseData.error) {
          this.dataSource.data = responseData.response;
        } else {
          this.resourcesService.openSnackBar(responseData.msg);
        }
      }, (error: HttpErrorResponse) => this.resourcesService.checkErrors(error)
    );
    this.isLoading = false;
  }

  public openDialog(typeDialog:string, elementData: HistoryOrder) {
    if (typeDialog === 'DETAILS') {
      this._dialog.open(DetailsStateOrderComponent, {
        data: elementData,
        disableClose: true,
        width: elementData.HIOR_EVID === null ? '500px' : '1000px'
      })
    }
  }
}
